UNIT mTQuadrat;

interface

uses        mSuM;
// Uses-Klausel ggf. anpassen

type
   TQuadrat = CLASS

     // Attribute
     private
        hatStift : Buntstift;
        zFarbe : GanzeZahl;
        zLinienstaerke : GanzeZahl;
        kenntMaus : Maus;
        Schrittweite : Zahl;
        zGroesse : Zahl;
        zxPosition : Zahl;
        zyPosition : Zahl;

     // Methoden
     private
        procedure loescheDich;
     public
        constructor init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus);
        procedure aktiviere;
        procedure BewegeUm(pZeichen:Zeichen);
        procedure deaktiviere;
        procedure setzeFarbe(pFarbe:GanzeZahl);
        procedure setzeGroesse(pGroesse:GanzeZahl);
        procedure zeichne;
        function getroffen : boolean;
        function groesse : Zahl;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TQuadrat: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loescheDich (private) ---------------------------------------
procedure TQuadrat.loescheDich;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- init (public) -----------------------------------------------
constructor TQuadrat.init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus);
begin

  zxPosition := phPosition;
  zyPosition := pvPosition;
  zGroesse := pGroesse;
  zFarbe := schwarz;

  hatStift := Buntstift.init;
  hatStift.bewegeBis (zxPosition, zyPosition);
  self.zeichne;
  Schrittweite := 5;
  kenntMaus := pMaus;
end;

//-------- aktiviere (public) ------------------------------------------
procedure TQuadrat.aktiviere;
begin
self.loescheDich;
hatStift.setzeLinienbreite(4);
self.zeichne
end;

//-------- BewegeUm (public) -------------------------------------------
procedure TQuadrat.BewegeUm(pZeichen:Zeichen);
begin

  if pZeichen = PfeilLinks then zxPosition := zxPosition - Schrittweite;
  if pZeichen = Pfeilrechts then zxPosition := zxPosition + Schrittweite;
  if pZeichen = PfeilOben then zyPosition := zyPosition - Schrittweite;
  if pZeichen = PfeilUnten then zyPosition := zyPosition + Schrittweite;

  self.loescheDich;
  hatStift.bewegeBis(zxPosition, zyPosition);
  self.zeichne
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TQuadrat.deaktiviere;
begin
 self.loescheDich;
 hatStift.setzeLinienbreite(1);
 self.zeichne
end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TQuadrat.setzeFarbe(pFarbe:GanzeZahl);
begin
  zFarbe:= pFarbe;
  self.zeichne;
end;

//-------- setzeGroesse (public) ---------------------------------------
procedure TQuadrat.setzeGroesse(pGroesse:GanzeZahl);
begin
  self.loescheDich;
  zGroesse := pGroesse;
  self.zeichne
end;

//-------- zeichne (public) --------------------------------------------
procedure TQuadrat.zeichne;
begin
  hatStift.setzeFarbe(zFarbe);
  hatStift.zeichneRechteck (zGroesse, zGroesse);
end;

//-------- getroffen (public) ------------------------------------------
function TQuadrat.getroffen : boolean;
begin
if (kenntMaus.hposition >= self.zxPosition)
and (kenntMaus.hposition <= self.zxPosition + zGroesse)
and (kenntMaus.vposition >= self.zyPosition)
and (kenntMaus.vposition <= zyPosition + zGroesse)
then result := true
end;

//-------- groesse (public) --------------------------------------------
function TQuadrat.groesse : Zahl;
begin
  result := zGroesse
end;

//-------- hPosition (public) ------------------------------------------
function TQuadrat.hPosition : Zahl;
begin
  result := zxposition
end;

//-------- vPosition (public) ------------------------------------------
function TQuadrat.vPosition : Zahl;
begin
  result := zyposition
end;

//-------- gibFrei (public) --------------------------------------------

destructor TQuadrat.gibFrei;
begin
  hatStift.gibFrei
end;

end.
