UNIT mTDreieck;

interface

uses  mSuM;

type
   TDreieck = CLASS
     // Attribute
     private
        dieMaus  : Maus;
        hatStift : Buntstift;
        g, XPos, YPos : Zahl;
        Farbe : ganzeZahl;
     // Methoden
     public
        procedure aktiviere;
        procedure deaktiviere;
        constructor init(x1,y1: Zahl; groesse : ganzeZahl);
        procedure loesche;
        procedure zeichne;
        procedure bewege(richtung : ganzeZahl);
        procedure setzeGroesse(gr : ganzeZahl);
        procedure setzeFarbe(f :ganzeZahl);
        function getroffen : boolean;
        destructor gibFrei;
   end;

implementation

//+---------------------------------------------------------------------
//|         TDreieck: Methodendefinition
//+---------------------------------------------------------------------

//-------- aktiviere (public) ------------------------------------------
procedure TDreieck.aktiviere;
begin
  hatStift.setzeLinienBreite(2);
  self.zeichne;
end;

procedure TDreieck.deaktiviere;
begin
  self.loesche;
  hatStift.setzeLinienBreite(1);
  self.zeichne;
end;

//-------- init (public) -----------------------------------------------
constructor TDreieck.init(x1,y1: Zahl; groesse : ganzeZahl);
begin
 dieMaus := Maus.init;
 hatStift := Buntstift.init;
 hatStift.setzeLinienBreite(1);
 Farbe := 13;
 XPos := x1; YPos := y1;g := groesse;
 self.zeichne;
end;
//-------- gibFrei     (public) -----------------------------------------
destructor TDreieck.gibFrei;
begin
  dieMaus.gibFrei;
  hatStift.gibFrei;
end;

//-------- loesche (public) --------------------------------------------
procedure TDreieck.loesche;
begin
  hatStift.setzeLinienBreite(2);
  hatStift.radiere;
  self.zeichne;
  hatStift.normal;
end;

//-------- zeichne (public) --------------------------------------------
procedure TDreieck.zeichne;
begin
  hatStift.bewegeBis(xPos,yPos);
  hatStift.setzeFarbe(farbe);
  hatStift.runter;
  hatStift.bewegeUm(g);
  hatStift.dreheUm(135);
  hatStift.bewegeUm(SQRT(2*g*g));
  hatStift.dreheUm(135);
  hatStift.bewegeUm(g);
  hatStift.hoch;
  hatStift.dreheBis(0);
end;

//-------- bewege (public) -----------------------------------------
procedure TDreieck.bewege(richtung : ganzeZahl);
begin
  self.loesche;
  case richtung of
   1 : xPos := xPos + 5;
   2 : yPos := yPos + 5;
   3 : xPos := xPos - 5;
   4 : yPos := yPos - 5;
  end;
  self.zeichne;
end;

//----------- size (public) -----------------------------------------
procedure TDreieck.setzeGroesse(gr : ganzeZahl);
begin
 self.loesche;
 g := (gr-48)*40;
 self.aktiviere;
end;
//----------- setzeFarbe (public) -------------------------------------
procedure TDreieck.setzeFarbe(f :ganzeZahl);
begin
  farbe := f;
  self.aktiviere;
end;

//-------- getroffen (public) -----------------------------------------
function TDreieck.getroffen : boolean;
begin
  If ((dieMaus.hposition > XPos)
      AND (dieMaus.hposition < XPos+g))
      AND ((dieMaus.vposition < YPos)
      AND (dieMaus.vposition > (YPos-g-xPos+dieMaus.hPosition)))
  Then result := true
  else result := false;
end;

end.
