UNIT mTKreis;

interface

uses  mSuM;
// Uses-Klausel ggf. anpassen

type
   TKreis = CLASS

     // Attribute
     private
        r : real;
        xM : real;
        yM : real;
     public
        hatStift : Buntstift;
        zGroesse : Zahl;

     //Objektbeziehungen:
        // hatBuntStift : BuntStift;

     // Methoden
     private
        procedure zeichneDich(px,py,pRadius:real);
     public
        constructor init(px,py,pRadius:real);
        procedure aktiviere;
        procedure bewegeUm(pRichtung:char);
        procedure deaktiviere;
        function getroffen(pXPos,pYPos:real) : boolean;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKreis: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichneDich (private) ---------------------------------------
procedure TKreis.zeichneDich(px,py,pRadius:real);
begin
  hatStift.bewegeBis(px,py);
  hatStift.zeichneKreis(pRadius);
end;

//-------- init (public) -----------------------------------------------
constructor TKreis.init(px,py,pRadius:real);
begin
  xM := px; yM := py; r := pRadius;
  hatStift := BuntStift.init;
  self.zeichneDich(xM,yM,r);
end;

//-------- aktiviere (public) ------------------------------------------
procedure TKreis.aktiviere;
begin
  hatStift.setzeLinienBreite(2);
  self.zeichneDich(xM,yM,r);
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TKreis.bewegeUm(pRichtung:char);
begin
  hatStift.wechsle;
  self.zeichneDich(xM,yM,r);
  hatStift.wechsle;
  case pRichtung of
    pfeiloben : yM := yM - 1;
    pfeilunten: yM := yM + 1;
    pfeillinks : xM := xM - 1;
    pfeilrechts : xM := xM + 1;
   end;
  self.zeichneDich(xM,yM,r);
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TKreis.deaktiviere;
begin
  hatStift.radiere;
  self.zeichneDich(xM,yM,r);
  hatStift.normal;
  hatStift.setzeLinienBreite(1);
  self.zeichneDich(xM,yM,r);
end;

//-------- getroffen (public) ------------------------------------------
function TKreis.getroffen(pXPos,pYPos:real) : boolean;
begin
  result := (pXPos-xM)*(pXPos-xM) + (pyPos-yM)*(pyPos-yM) < r*r
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKreis.gibFrei;
begin
  hatStift.gibFrei
end;

end.
