UNIT mTFigur;

interface

uses         mSuM;
// Uses-Klausel ggf. anpassen

type
   TFigur = CLASS

     // Attribute
     protected
        hatStift : Buntstift;
        zFarbe : GanzeZahl;
        zLinienstaerke : GanzeZahl;
        kenntMaus : Maus;
        Schrittweite : Zahl;
        zGroesse : Zahl;
        zxPosition : Zahl;
        zyPosition : Zahl;

     //Objektbeziehungen:
        // kenntTAnwendung () of TAnwendung;

     // Methoden
     private
        procedure loescheDich;
     protected
        procedure zeichne; virtual; abstract;
        function getroffen : boolean; virtual; abstract;
     public
        constructor init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus);
        procedure aktiviere;
        procedure BewegeUm(pZeichen:Zeichen);
        procedure deaktiviere;
        procedure setzeFarbe(pFarbe:GanzeZahl);
        procedure setzeGroesse(pGroesse:GanzeZahl);
        function groesse : Zahl;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TFigur: Methodendefinition 
//+---------------------------------------------------------------------

//-------- loescheDich (private) ---------------------------------------
procedure TFigur.loescheDich;
begin
  hatStift.radiere;
  self.Zeichne;
  hatStift.normal
end;

//-------- init (public) -----------------------------------------------
constructor TFigur.init(phPosition,pvPosition,pGroesse:GanzeZahl;pMaus:Maus);
begin

  zxPosition := phPosition;
  zyPosition := pvPosition;
  zGroesse := pGroesse;
  zFarbe := schwarz;

  hatStift := Buntstift.init;
  hatStift.bewegeBis (zxPosition, zyPosition);
  self.zeichne;
  Schrittweite := 5;
  kenntMaus := pMaus;
end;

//-------- aktiviere (public) ------------------------------------------
procedure TFigur.aktiviere;
begin
self.loescheDich;
hatStift.setzeLinienbreite(4);
self.zeichne
end;

//-------- BewegeUm (public) -------------------------------------------
procedure TFigur.BewegeUm(pZeichen:Zeichen);
begin

  if pZeichen = PfeilLinks then zxPosition := zxPosition - Schrittweite;
  if pZeichen = Pfeilrechts then zxPosition := zxPosition + Schrittweite;
  if pZeichen = PfeilOben then zyPosition := zyPosition - Schrittweite;
  if pZeichen = PfeilUnten then zyPosition := zyPosition + Schrittweite;

  self.loescheDich;
  hatStift.bewegeBis(zxPosition, zyPosition);
  self.zeichne
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TFigur.deaktiviere;
begin
 self.loescheDich;
 hatStift.setzeLinienbreite(1);
 self.zeichne
end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TFigur.setzeFarbe(pFarbe:GanzeZahl);
begin
  zFarbe:= pFarbe;
  self.zeichne;
end;

//-------- setzeGroesse (public) ---------------------------------------
procedure TFigur.setzeGroesse(pGroesse:GanzeZahl);
begin
  self.loescheDich;
  zGroesse := pGroesse;
  self.zeichne
end;

//-------- groesse (public) --------------------------------------------
function TFigur.groesse : Zahl;
begin
  result := zGroesse
end;

//-------- hPosition (public) ------------------------------------------
function TFigur.hPosition : Zahl;
begin
  result := zxposition
end;

//-------- vPosition (public) ------------------------------------------
function TFigur.vPosition : Zahl;
begin
  result := zyposition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TFigur.gibFrei;
begin
  hatStift.gibFrei
end;

end.
