UNIT mTAnwendung;

interface

uses  mSuM,MTKreis;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieTastatur : Tastatur;
        aktiverKreis : TKreis;
        hatKreis1 : TKreis;
        hatKreis2 : TKreis;
        hatKreis3 : TKreis;

     //Objektbeziehungen:
        // hatKreis1, // hatKreis2, // hatKreis3 : Kreis;
        // kenntKreis : Kreis;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieTastatur   := Tastatur.init;
  hatKreis1    := TKreis.init(100,100,50);
  hatKreis2    := TKreis.init(300,200,100);
  hatKreis3    := TKreis.init(500,100,100);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
  // Aktionsteil
  aktiverKreis := hatKreis1;
  aktiverKreis.aktiviere;
  repeat
    if dieMaus.istGedrueckt then  // den zu aktivierenden Kreis bestimmen
    begin
      aktiverKreis.deaktiviere;
      if hatKreis1.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiverKreis := hatKreis1;
      if hatKreis2.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiverKreis := hatKreis2;
      if hatKreis3.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiverKreis := hatKreis3;
      aktiverKreis.aktiviere;
    end;

    if dieTastatur.wurdeGedrueckt then  // Tastendruck auswerten
    begin
      case dieTastatur.zeichen of
        PFEILOBEN   : aktiverKreis.bewegeUm(0,-10);
        PFEILUNTEN  : aktiverKreis.bewegeUm(0,10);
        PFEILRECHTS : aktiverKreis.bewegeUm(10,0);
        PFEILLINKS  : aktiverKreis.bewegeUm(-10,0);
        '1' : aktiverKreis.setzeGroesse(20);
        '2' : aktiverKreis.setzeGroesse(40);
        '3' : aktiverKreis.setzeGroesse(60);
        '4' : aktiverKreis.setzeGroesse(80);
        '5' : aktiverKreis.setzeGroesse(100);
        '6' : aktiverKreis.setzeGroesse(120);
        '7' : aktiverKreis.setzeGroesse(140);
        '8' : aktiverKreis.setzeGroesse(160);
        '9' : aktiverKreis.setzeGroesse(180);
        'r' : aktiverKreis.setzeFarbe(ROT);
        'b' : aktiverKreis.setzeFarbe(BLAU);
        'g' : aktiverKreis.setzeFarbe(GRUEN);
        's' : aktiverKreis.setzeFarbe(SCHWARZ);
        'o' : aktiverKreis.setzeFarbe(ORANGE);
        'c' : aktiverKreis.setzeFarbe(CYAN);
        'm' : aktiverKreis.setzeFarbe(MAGENTA);
        'w' : aktiverKreis.setzeFarbe(WEISS);
      end;
      dieTastatur.weiter
    end
  until dieMaus.doppelklick;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  hatKreis3.gibFrei;
  hatKreis2.gibFrei;
  hatKreis1.gibFrei;
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
