UNIT mTKreis;

interface

uses    mSuM;
// Uses-Klausel ggf. anpassen

type
   TKreis = CLASS

     // Attribute
     public
        hatStift : Buntstift;
        zGroesse : Zahl;

     //Objektbeziehungen:
        // kenntTAnwendung () of TAnwendung;

     // Methoden
     private
        procedure zeichne;
     public
        constructor init(pHPosition,pVPosition,pGroesse:Zahl);
        procedure aktiviere;
        procedure bewegeBis(pHPosition,pVPosition:Zahl);
        procedure bewegeUm(pHDistanz,pVDistanz:Zahl);
        procedure deaktiviere;
        procedure setzeFarbe(pFarbe:GanzeZahl);
        procedure setzeGroesse(pGroesse:Zahl);
        function getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert;
        function groesse : Zahl;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TKreis: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TKreis.zeichne;
begin
  hatStift.zeichneKreis(zGroesse)
end;

//-------- init (public) -----------------------------------------------
constructor TKreis.init(pHPosition,pVPosition,pGroesse:Zahl);
begin
  hatStift := Buntstift.init;
  zGroesse:=pGroesse;
  hatstift.bewegeBis(pHPosition,pVPosition);
  hatStift.wechsle;
  self.zeichne
end;

//-------- aktiviere (public) ------------------------------------------
procedure TKreis.aktiviere;
begin
  self.zeichne;
  hatStift.setzeLinienbreite(3);
  self.zeichne
end;

//-------- bewegeBis (public) ------------------------------------------
procedure TKreis.bewegeBis(pHPosition,pVPosition:Zahl);
begin
  self.zeichne;
  hatStift.bewegeBis(pHPosition,pVPosition);
  self.zeichne
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TKreis.bewegeUm(pHDistanz,pVDistanz:Zahl);
begin
  self.bewegeBis(self.hPosition+pHDistanz, self.vPosition+pVDistanz)
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TKreis.deaktiviere;
begin
  self.zeichne;
  hatStift.setzeLinienbreite(1);
  self.zeichne
end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TKreis.setzeFarbe(pFarbe:GanzeZahl);
begin
  self.zeichne;
  hatStift.setzeFarbe(pFarbe);
  self.zeichne
end;

//-------- setzeGroesse (public) ---------------------------------------
procedure TKreis.setzeGroesse(pGroesse:Zahl);
begin
  self.zeichne;
  zGroesse := pGroesse;
  self.zeichne
end;

//-------- getroffen (public) ------------------------------------------
function TKreis.getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert;
begin
  result := (pHPosition-self.hPosition)*(pHPosition-self.hPosition)+
    (pVPosition-self.vPosition)*(pVPosition-self.vPosition) < zGroesse*zGroesse
end;

//-------- groesse (public) --------------------------------------------
function TKreis.groesse : Zahl;
begin
  result := zGroesse
end;

//-------- hPosition (public) ------------------------------------------
function TKreis.hPosition : Zahl;
begin
  result := hatStift.hPosition
end;

//-------- vPosition (public) ------------------------------------------
function TKreis.vPosition : Zahl;
begin
  result := hatStift.vPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TKreis.gibFrei;
begin
  self.zeichne;
  hatStift.gibFrei
end;

end.
