UNIT mTAnwendung;

interface

uses  mSuM, mTKreis, mTQuadrat, mTFigur;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieTastatur : Tastatur;
        aktiveFigur : TFigur;
        hatKreis1 : TKreis;
        hatKreis2 : TKreis;
        hatKreis3 : TKreis;
        hatQuadrat : TQuadrat;

     //Objektbeziehungen:
        // hatKreis1, // hatKreis2, // hatKreis3 : Kreis;
        // kenntKreis : Kreis;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieTastatur   := Tastatur.init;
  hatKreis1    := TKreis.init(100,100,50);
  hatKreis2    := TKreis.init(300,200,100);
  hatKreis3    := TKreis.init(500,100,100);
  hatQuadrat := TQuadrat.init(200,400,50);

end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
  // Aktionsteil
  aktiveFigur := hatKreis1;
  aktiveFigur.aktiviere;
  repeat
    if dieMaus.istGedrueckt then  // den zu aktivierenden Kreis bestimmen
    begin
      aktiveFigur.deaktiviere;
      if hatKreis1.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatKreis1;
      if hatKreis2.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatKreis2;
      if hatKreis3.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatKreis3;
      if hatQuadrat.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatQuadrat;
      aktiveFigur.aktiviere;
    end;

    if dieTastatur.wurdeGedrueckt then  // Tastendruck auswerten
    begin
      case dieTastatur.zeichen of
        PFEILOBEN   : aktiveFigur.bewegeUm(0,-10);
        PFEILUNTEN  : aktiveFigur.bewegeUm(0,10);
        PFEILRECHTS : aktiveFigur.bewegeUm(10,0);
        PFEILLINKS  : aktiveFigur.bewegeUm(-10,0);
        '1' : aktiveFigur.setzeGroesse(20);
        '2' : aktiveFigur.setzeGroesse(40);
        '3' : aktiveFigur.setzeGroesse(60);
        '4' : aktiveFigur.setzeGroesse(80);
        '5' : aktiveFigur.setzeGroesse(100);
        '6' : aktiveFigur.setzeGroesse(120);
        '7' : aktiveFigur.setzeGroesse(140);
        '8' : aktiveFigur.setzeGroesse(160);
        '9' : aktiveFigur.setzeGroesse(180);
        'r' : aktiveFigur.setzeFarbe(ROT);
        'b' : aktiveFigur.setzeFarbe(BLAU);
        'g' : aktiveFigur.setzeFarbe(GRUEN);
        's' : aktiveFigur.setzeFarbe(SCHWARZ);
        'o' : aktiveFigur.setzeFarbe(ORANGE);
        'c' : aktiveFigur.setzeFarbe(CYAN);
        'm' : aktiveFigur.setzeFarbe(MAGENTA);
        'w' : aktiveFigur.setzeFarbe(WEISS);
      end;
      dieTastatur.weiter
    end
  until dieMaus.doppelklick;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  hatKreis3.gibFrei;
  hatKreis2.gibFrei;
  hatKreis1.gibFrei;
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
