UNIT mTAnwendung;

interface

uses   mSuM,MTQuadrat;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieTastatur : Tastatur;
        aktiverQuadrat : TQuadrat;
        hatQuadrat1 : TQuadrat;
        hatQuadrat2 : TQuadrat;
        hatQuadrat3 : TQuadrat;

     //Objektbeziehungen:
        // hatTQuadrat1, // hatTQuadrat2, // hatTQuadrat3 : TQuadrat;
        // kenntTQuadrat : TQuadrat;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieTastatur   := Tastatur.init;
  hatQuadrat1    := TQuadrat.init(100,100,50);
  hatQuadrat2    := TQuadrat.init(300,200,100);
  hatQuadrat3    := TQuadrat.init(500,100,100);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
  // Aktionsteil
  aktiverQuadrat := hatQuadrat1;
  aktiverQuadrat.aktiviere;
  repeat
    if dieMaus.istGedrueckt then  // den zu aktivierenden Quadrat bestimmen
    begin
      aktiverQuadrat.deaktiviere;
      if hatQuadrat1.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiverQuadrat := hatQuadrat1;
      if hatQuadrat2.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiverQuadrat := hatQuadrat2;
      if hatQuadrat3.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiverQuadrat := hatQuadrat3;
      aktiverQuadrat.aktiviere;
    end;

    if dieTastatur.wurdeGedrueckt then  // Tastendruck auswerten
    begin
      case dieTastatur.zeichen of
        PFEILOBEN   : aktiverQuadrat.bewegeUm(0,-10);
        PFEILUNTEN  : aktiverQuadrat.bewegeUm(0,10);
        PFEILRECHTS : aktiverQuadrat.bewegeUm(10,0);
        PFEILLINKS  : aktiverQuadrat.bewegeUm(-10,0);
        '1' : aktiverQuadrat.setzeGroesse(20);
        '2' : aktiverQuadrat.setzeGroesse(40);
        '3' : aktiverQuadrat.setzeGroesse(60);
        '4' : aktiverQuadrat.setzeGroesse(80);
        '5' : aktiverQuadrat.setzeGroesse(100);
        '6' : aktiverQuadrat.setzeGroesse(120);
        '7' : aktiverQuadrat.setzeGroesse(140);
        '8' : aktiverQuadrat.setzeGroesse(160);
        '9' : aktiverQuadrat.setzeGroesse(180);
        'r' : aktiverQuadrat.setzeFarbe(ROT);
        'b' : aktiverQuadrat.setzeFarbe(BLAU);
        'g' : aktiverQuadrat.setzeFarbe(GRUEN);
        's' : aktiverQuadrat.setzeFarbe(SCHWARZ);
        'o' : aktiverQuadrat.setzeFarbe(ORANGE);
        'c' : aktiverQuadrat.setzeFarbe(CYAN);
        'm' : aktiverQuadrat.setzeFarbe(MAGENTA);
        'w' : aktiverQuadrat.setzeFarbe(WEISS);
      end;
      dieTastatur.weiter
    end
  until dieMaus.doppelklick;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  hatQuadrat3.gibFrei;
  hatQuadrat2.gibFrei;
  hatQuadrat1.gibFrei;
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
