UNIT mTAnwendung;

interface

uses    mSuM,mTFigur,mTKreis,mTRechteck,mTQuadrat,mTDreieck;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        dieTastatur : Tastatur;
        hatDreieck : TDreieck;
        aktiveFigur : TFigur;
        hatKreis1 : TKreis;
        hatKreis2 : TKreis;
        hatQuadrat : TQuadrat;
        hatRechteck : TRechteck;

     //Objektbeziehungen:
        // hatTKreis1, // hatTKreis2 : TKreis;
        // hatTQuadrat : TQuadrat;
        // hatTRechteck : TRechteck;
        // hatTDreieck : TDreieck;
        // kenntTFigur : TFigur;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  dieTastatur   := Tastatur.init;
  hatKreis1     := TKreis.init(100,100,50);
  hatKreis2     := TKreis.init(300,200,100);
  hatQuadrat    := TQuadrat.init(400,300,100);
  hatDreieck    := TDreieck.init(200,400,100);
  hatRechteck   := TRechteck.init(400,50,50,150); 
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
  // Aktionsteil
  aktiveFigur := hatKreis1;
  aktiveFigur.aktiviere;
  repeat
    if dieMaus.istGedrueckt then  // den zu aktivierenden Kreis bestimmen
    begin
      aktiveFigur.deaktiviere;
      if hatKreis1.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatKreis1;
      if hatKreis2.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatKreis2;
      if hatRechteck.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatRechteck;
      if hatQuadrat.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatQuadrat;
      if hatDreieck.getroffen(dieMaus.hPosition,dieMaus.vPosition) then
        aktiveFigur := hatDreieck;
      aktiveFigur.aktiviere;
    end;

    if dieTastatur.wurdeGedrueckt then  // Tastendruck auswerten
    begin
      case dieTastatur.zeichen of
        PFEILOBEN   : aktiveFigur.bewegeUm(0,-10);
        PFEILUNTEN  : aktiveFigur.bewegeUm(0,10);
        PFEILRECHTS : aktiveFigur.bewegeUm(10,0);
        PFEILLINKS  : aktiveFigur.bewegeUm(-10,0);
        '1' : aktiveFigur.setzeGroesse(20);
        '2' : aktiveFigur.setzeGroesse(40);
        '3' : aktiveFigur.setzeGroesse(60);
        '4' : aktiveFigur.setzeGroesse(80);
        '5' : aktiveFigur.setzeGroesse(100);
        '6' : aktiveFigur.setzeGroesse(120);
        '7' : aktiveFigur.setzeGroesse(140);
        '8' : aktiveFigur.setzeGroesse(160);
        '9' : aktiveFigur.setzeGroesse(180);
        'r' : aktiveFigur.setzeFarbe(ROT);
        'b' : aktiveFigur.setzeFarbe(BLAU);
        'g' : aktiveFigur.setzeFarbe(GRUEN);
        's' : aktiveFigur.setzeFarbe(SCHWARZ);
        'o' : aktiveFigur.setzeFarbe(ORANGE);
        'c' : aktiveFigur.setzeFarbe(CYAN);
        'm' : aktiveFigur.setzeFarbe(MAGENTA);
        'w' : aktiveFigur.setzeFarbe(WEISS);
      end;
      dieTastatur.weiter
    end
  until dieMaus.doppelklick;
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  hatKreis2.gibFrei;
  hatRechteck.gibFrei;
  hatQuadrat.gibFrei;
  hatDreieck.gibFrei;
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
