UNIT mTFigur;

interface

uses  mSuM;
// Uses-Klausel ggf. anpassen

type
   TFigur = CLASS

     // Attribute
     public
        hatStift : Buntstift;
        zGroesse : Zahl;

     //Objektbeziehungen:
        // hatBuntStift : BuntStift;
        // kenntTAnwendung () of TAnwendung;

     // Methoden
     public
        constructor init(pHPosition,pVPosition,pGroesse:Zahl);
        procedure aktiviere;
        procedure bewegeBis(pHPosition,pVPosition:Zahl);
        procedure bewegeUm(pHDistanz,pVDistanz:Zahl);
        procedure deaktiviere;
        procedure loesche;
        procedure setzeFarbe(pFarbe:GanzeZahl);
        procedure setzeGroesse(pGroesse:Zahl);
        procedure zeichne; virtual; abstract;
        function getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert; virtual; abstract;
        function groesse : Zahl;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TFigur: Methodendefinition 
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TFigur.init(pHPosition,pVPosition,pGroesse:Zahl);
begin
  hatStift := Buntstift.init;
  hatStift.wechsle;
  hatStift.setzeLinienbreite(2);
  zGroesse:=pGroesse;
  hatstift.bewegeBis(pHPosition,pVPosition);
  self.zeichne
end;

//-------- aktiviere (public) ------------------------------------------
procedure TFigur.aktiviere;
begin
  self.loesche;
  hatStift.setzeLinienbreite(3);
  self.zeichne
end;

//-------- bewegeBis (public) ------------------------------------------
procedure TFigur.bewegeBis(pHPosition,pVPosition:Zahl);
begin
  self.loesche;
  hatStift.bewegeBis(pHPosition,pVPosition);
  self.zeichne
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TFigur.bewegeUm(pHDistanz,pVDistanz:Zahl);
begin
  self.bewegeBis(self.hPosition+pHDistanz, self.vPosition+pVDistanz)
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TFigur.deaktiviere;
begin
  self.loesche;
  hatStift.setzeLinienbreite(2);
  self.zeichne
end;

//-------- loesche (public) --------------------------------------------
procedure TFigur.loesche;
begin
  self.zeichne;
end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TFigur.setzeFarbe(pFarbe:GanzeZahl);
begin
  self.loesche;
  hatStift.setzeFarbe(pFarbe);
  self.zeichne
end;

//-------- setzeGroesse (public) ---------------------------------------
procedure TFigur.setzeGroesse(pGroesse:Zahl);
begin
  self.loesche;
  zGroesse := pGroesse;
  self.zeichne
end;

//-------- groesse (public) --------------------------------------------
function TFigur.groesse : Zahl;
begin
  result := zGroesse
end;

//-------- hPosition (public) ------------------------------------------
function TFigur.hPosition : Zahl;
begin
  result := hatStift.hPosition
end;

//-------- vPosition (public) ------------------------------------------
function TFigur.vPosition : Zahl;
begin
  result := hatStift.vPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TFigur.gibFrei;
begin
  self.loesche;
  hatStift.gibFrei
end;

end.
