UNIT mTQuadrat;

interface

uses     mSuM;
// Uses-Klausel ggf. anpassen

type
   TQuadrat = CLASS

     // Attribute
     public
        hatStift : Buntstift;
        zGroesse : Zahl;

     // Methoden
     private
        procedure zeichne;
     public
        constructor init(pHPosition,pVPosition,pGroesse:Zahl);
        procedure aktiviere;
        procedure bewegeBis(pHPosition,pVPosition:Zahl);
        procedure bewegeUm(pHDistanz,pVDistanz:Zahl);
        procedure deaktiviere;
        procedure setzeFarbe(pFarbe:GanzeZahl);
        procedure setzeGroesse(pGroesse:Zahl);
        function getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert;
        function groesse : Zahl;
        function hPosition : Zahl;
        function vPosition : Zahl;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TQuadrat: Methodendefinition 
//+---------------------------------------------------------------------

//-------- zeichne (private) -------------------------------------------
procedure TQuadrat.zeichne;
begin
  hatStift.zeichneRechteck(zGroesse,zGroesse)
end;

//-------- init (public) -----------------------------------------------
constructor TQuadrat.init(pHPosition,pVPosition,pGroesse:Zahl);
begin
  hatStift := Buntstift.init;
  zGroesse:=pGroesse;
  hatstift.bewegeBis(pHPosition,pVPosition);
  hatStift.wechsle;
  self.zeichne
end;

//-------- aktiviere (public) ------------------------------------------
procedure TQuadrat.aktiviere;
begin
  self.zeichne;
  hatStift.setzeLinienbreite(3);
  self.zeichne
end;

//-------- bewegeBis (public) ------------------------------------------
procedure TQuadrat.bewegeBis(pHPosition,pVPosition:Zahl);
begin
  self.zeichne;
  hatStift.bewegeBis(pHPosition,pVPosition);
  self.zeichne
end;

//-------- bewegeUm (public) -------------------------------------------
procedure TQuadrat.bewegeUm(pHDistanz,pVDistanz:Zahl);
begin
  self.bewegeBis(self.hPosition+pHDistanz, self.vPosition+pVDistanz)
end;

//-------- deaktiviere (public) ----------------------------------------
procedure TQuadrat.deaktiviere;
begin
  self.zeichne;
  hatStift.setzeLinienbreite(1);
  self.zeichne
end;

//-------- setzeFarbe (public) -----------------------------------------
procedure TQuadrat.setzeFarbe(pFarbe:GanzeZahl);
begin
  self.zeichne;
  hatStift.setzeFarbe(pFarbe);
  self.zeichne
end;

//-------- setzeGroesse (public) ---------------------------------------
procedure TQuadrat.setzeGroesse(pGroesse:Zahl);
begin
  self.zeichne;
  zGroesse := pGroesse;
  self.zeichne
end;

//-------- getroffen (public) ------------------------------------------
function TQuadrat.getroffen(pHPosition,pVPosition:Zahl) : Wahrheitswert;
begin
  result := (pHPosition >= self.hPosition) and
            (pVPosition >= self.vPosition) and
            (pHPosition <= self.hPosition + zGroesse) and
            (pVPosition <= self.vPosition + zGroesse)
end;

//-------- groesse (public) --------------------------------------------
function TQuadrat.groesse : Zahl;
begin
  result := zGroesse
end;

//-------- hPosition (public) ------------------------------------------
function TQuadrat.hPosition : Zahl;
begin
  result := hatStift.hPosition
end;

//-------- vPosition (public) ------------------------------------------
function TQuadrat.vPosition : Zahl;
begin
  result := hatStift.vPosition
end;

//-------- gibFrei (public) --------------------------------------------
destructor TQuadrat.gibFrei;
begin
  self.zeichne;
  hatStift.gibFrei
end;

end.
